(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('@fullcalendar/angular'), require('@fullcalendar/timegrid'), require('@fullcalendar/daygrid'), require('@fullcalendar/interaction'), require('@angular/platform-browser')) :
    typeof define === 'function' && define.amd ? define('@eqproject/eqp-calendar', ['exports', '@angular/core', '@angular/common', '@angular/forms', '@fullcalendar/angular', '@fullcalendar/timegrid', '@fullcalendar/daygrid', '@fullcalendar/interaction', '@angular/platform-browser'], factory) :
    (global = global || self, factory((global.eqproject = global.eqproject || {}, global.eqproject['eqp-calendar'] = {}), global.ng.core, global.ng.common, global.ng.forms, global.angular, global.timeGridPlugin, global.dayGridPlugin, global.interactionPlugin, global.ng.platformBrowser));
}(this, (function (exports, core, common, forms, angular, timeGridPlugin, dayGridPlugin, interactionPlugin, platformBrowser) { 'use strict';

    timeGridPlugin = timeGridPlugin && Object.prototype.hasOwnProperty.call(timeGridPlugin, 'default') ? timeGridPlugin['default'] : timeGridPlugin;
    dayGridPlugin = dayGridPlugin && Object.prototype.hasOwnProperty.call(dayGridPlugin, 'default') ? dayGridPlugin['default'] : dayGridPlugin;
    interactionPlugin = interactionPlugin && Object.prototype.hasOwnProperty.call(interactionPlugin, 'default') ? interactionPlugin['default'] : interactionPlugin;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var EqpCalendarService = /** @class */ (function () {
        function EqpCalendarService() {
        }
        EqpCalendarService.ɵprov = core.ɵɵdefineInjectable({ factory: function EqpCalendarService_Factory() { return new EqpCalendarService(); }, token: EqpCalendarService, providedIn: "root" });
        EqpCalendarService = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], EqpCalendarService);
        return EqpCalendarService;
    }());

    var EqpCalendarComponent = /** @class */ (function () {
        function EqpCalendarComponent() {
            this.eventList = new Array();
            this.customStyle = { 'text-transform': 'capitalize' };
            this.initialView = "dayGridMonth";
            this.firstDay = 1;
            this.contentHeight = null;
            this.locale = "it-IT";
            this.monthButtonText = "Mese";
            this.weekButtonText = "Settimana";
            this.dayButtonText = "Giorno";
            this.todayButtonText = "Oggi";
            this.listButtonText = "Lista";
            this.headerToolbarStart = 'title';
            this.headerToolbarCenter = "dayGridMonth,timeGridWeek,timeGridDay";
            this.headerToolbarEnd = "today prev,next";
            this.allDayText = "Tutto il giorno";
            this.eventOrder = null;
            this.onViewDateChange = new core.EventEmitter();
            this.onDateClick = new core.EventEmitter();
            this.onEventClick = new core.EventEmitter();
            this.calendarOptions = {};
        }
        EqpCalendarComponent.prototype.ngOnInit = function () {
        };
        EqpCalendarComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            if (this.calendarComponent)
                this.calendarApi = this.calendarComponent.getApi();
            this.configureCalendar();
            setTimeout(function () {
                _this.calendarApi.updateSize();
            }, 190);
        };
        EqpCalendarComponent.prototype.ngOnChanges = function (changes) {
            if (changes['eventList'] != undefined && changes['eventList'].firstChange == false && JSON.stringify(changes['eventList'].currentValue) != JSON.stringify(changes['eventList'].previousValue)) {
                this.calendarOptions.events = this.eventList;
                this.calendarApi.refetchEvents();
            }
        };
        EqpCalendarComponent.prototype.configureCalendar = function () {
            var _this = this;
            this.calendarOptions = {
                initialView: this.initialView,
                firstDay: this.firstDay,
                contentHeight: this.contentHeight,
                locale: this.locale,
                customButtons: {
                    today: {
                        text: this.todayButtonText,
                        click: function (event) {
                            _this.calendarApi.today();
                            _this.viewDateChange();
                        }
                    },
                    prev: {
                        click: function (event) {
                            _this.calendarApi.prev();
                            _this.viewDateChange();
                        }
                    },
                    next: {
                        click: function (event) {
                            _this.calendarApi.next();
                            _this.viewDateChange();
                        }
                    },
                    dayGridMonth: {
                        text: this.monthButtonText,
                        click: function (event) {
                            _this.calendarApi.changeView("dayGridMonth");
                            _this.viewDateChange();
                        }
                    },
                    timeGridWeek: {
                        text: this.weekButtonText,
                        click: function (event) {
                            _this.calendarApi.changeView("timeGridWeek");
                            _this.viewDateChange();
                        }
                    },
                    timeGridDay: {
                        text: this.dayButtonText,
                        click: function (event) {
                            _this.calendarApi.changeView("timeGridDay");
                            _this.viewDateChange();
                        }
                    }
                },
                headerToolbar: {
                    start: this.headerToolbarStart,
                    center: this.headerToolbarCenter,
                    end: this.headerToolbarEnd,
                },
                buttonText: {
                    month: this.monthButtonText,
                    week: this.weekButtonText,
                    day: this.dayButtonText,
                    today: this.todayButtonText,
                    list: this.listButtonText
                },
                allDayText: this.allDayText,
                eventClick: function (event) { _this.eventClick(event); },
                dateClick: this.dateClick.bind(this),
                eventOrder: function (eventA, eventB) { return ((eventA && eventB && _this.eventOrder) ? _this.eventOrder(eventA, eventB) : 0); }
            };
            this.calendarOptions.events = this.eventList;
            this.calendarApi.refetchEvents();
        };
        EqpCalendarComponent.prototype.viewDateChange = function () {
            var newRange = {
                dateStart: this.calendarApi.view.currentStart,
                dateEnd: this.calendarApi.view.currentEnd,
                viewMode: this.calendarApi.view.type
            };
            this.onViewDateChange.emit(newRange);
        };
        EqpCalendarComponent.prototype.dateClick = function (event) {
            this.onDateClick.emit(event.date);
        };
        EqpCalendarComponent.prototype.eventClick = function (event) {
            this.onEventClick.emit(event.event);
        };
        __decorate([
            core.Input("EventList")
        ], EqpCalendarComponent.prototype, "eventList", void 0);
        __decorate([
            core.Input("CustomStyle")
        ], EqpCalendarComponent.prototype, "customStyle", void 0);
        __decorate([
            core.Input("InitialView")
        ], EqpCalendarComponent.prototype, "initialView", void 0);
        __decorate([
            core.Input("FirstDay")
        ], EqpCalendarComponent.prototype, "firstDay", void 0);
        __decorate([
            core.Input("ContentHeight")
        ], EqpCalendarComponent.prototype, "contentHeight", void 0);
        __decorate([
            core.Input("Locale")
        ], EqpCalendarComponent.prototype, "locale", void 0);
        __decorate([
            core.Input("MonthButtonText")
        ], EqpCalendarComponent.prototype, "monthButtonText", void 0);
        __decorate([
            core.Input("WeekButtonText")
        ], EqpCalendarComponent.prototype, "weekButtonText", void 0);
        __decorate([
            core.Input("DayButtonText")
        ], EqpCalendarComponent.prototype, "dayButtonText", void 0);
        __decorate([
            core.Input("TodayButtonText")
        ], EqpCalendarComponent.prototype, "todayButtonText", void 0);
        __decorate([
            core.Input("ListButtonText")
        ], EqpCalendarComponent.prototype, "listButtonText", void 0);
        __decorate([
            core.Input("HeaderToolbarStart")
        ], EqpCalendarComponent.prototype, "headerToolbarStart", void 0);
        __decorate([
            core.Input("HeaderToolbarCenter")
        ], EqpCalendarComponent.prototype, "headerToolbarCenter", void 0);
        __decorate([
            core.Input("HeaderToolbarEnd")
        ], EqpCalendarComponent.prototype, "headerToolbarEnd", void 0);
        __decorate([
            core.Input("AllDayText")
        ], EqpCalendarComponent.prototype, "allDayText", void 0);
        __decorate([
            core.Input("EventOrder")
        ], EqpCalendarComponent.prototype, "eventOrder", void 0);
        __decorate([
            core.Output("OnViewDateChange")
        ], EqpCalendarComponent.prototype, "onViewDateChange", void 0);
        __decorate([
            core.Output("OnDateClick")
        ], EqpCalendarComponent.prototype, "onDateClick", void 0);
        __decorate([
            core.Output("OnEventClick")
        ], EqpCalendarComponent.prototype, "onEventClick", void 0);
        __decorate([
            core.ViewChild('calendar')
        ], EqpCalendarComponent.prototype, "calendarComponent", void 0);
        EqpCalendarComponent = __decorate([
            core.Component({
                selector: 'eqp-calendar',
                template: "<full-calendar [options]=\"calendarOptions\" #calendar [ngStyle]=\"customStyle\"></full-calendar>",
                styles: [""]
            })
        ], EqpCalendarComponent);
        return EqpCalendarComponent;
    }());

    angular.FullCalendarModule.registerPlugins([
        dayGridPlugin,
        timeGridPlugin,
        interactionPlugin
    ]);
    var EqpCalendarModule = /** @class */ (function () {
        function EqpCalendarModule() {
        }
        EqpCalendarModule = __decorate([
            core.NgModule({
                declarations: [EqpCalendarComponent],
                imports: [
                    common.CommonModule,
                    platformBrowser.BrowserModule,
                    forms.FormsModule,
                    forms.ReactiveFormsModule,
                    angular.FullCalendarModule
                ],
                exports: [EqpCalendarComponent]
            })
        ], EqpCalendarModule);
        return EqpCalendarModule;
    }());

    var ViewDateChangeEvent = /** @class */ (function () {
        function ViewDateChangeEvent() {
        }
        return ViewDateChangeEvent;
    }());

    exports.EqpCalendarComponent = EqpCalendarComponent;
    exports.EqpCalendarModule = EqpCalendarModule;
    exports.EqpCalendarService = EqpCalendarService;
    exports.ViewDateChangeEvent = ViewDateChangeEvent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=eqproject-eqp-calendar.umd.js.map
